
#importation de tous les éléments nécessaires
from tkinter import *
from datetime import datetime
from tkinter.messagebox import *

#varables
nb_rouge=0
pair=0

#fonctions,

def update_image():
    e_im.delete(0,END)  #efface les données de la barre d'insertion au dessus de l'image
    e_im.insert(0, "          Image : "+str(datetime.now()))   #renseigne la date et l'heure dans la barre d'insertion
    photo=PhotoImage(file="image_test.png")       #la suite affiche l'image voulue dans un canvas
    canvas=Canvas(image_frame, width=photo.width(), height=photo.height(), bg="yellow")
    canvas.create_image(0,0, anchor=NW, image=photo)
    canvas.pack()
#fonction update image sert à afficher la dernière image utilisée dans le programme
#Change aussi la date et l'heure pour se repérer en regardant le programme
#dans notre cas on reafiche toujours l'image test qui est la seule qu'on a pu manipuler
#mais on peut s'imaginer aller chercher la dernière image correctement définie en entrée du programme

def switch():
    if askyesno(None, 'Etes-vous sûr de vouloir changer de configuration ?'):
        global pair
        pair =pair+1
        e.delete(0,END)
        if pair%2 == 0:
            e.insert(0, "   Tri par couleur")
        else: e.insert(0, "   Tri par forme")
#fonction switch, sert à changer le mode de tri si pair est pair on est en tri de couleur, sinon tri de forme
#tri de couleur par défaut au démarage

def zero_comp():
    global nb_rouge
    nb_rouge=0
    eglo.delete(0,END)
    eglo.insert(0, nb_rouge)
    e_rouge.delete(0,END)
    e_rouge.insert(0, nb_rouge)
    e_bleu.delete(0,END)
    e_bleu.insert(0, nb_rouge)
    e_vert.delete(0,END)
    e_vert.insert(0, nb_rouge)
    e_orange.delete(0,END)
    e_orange.insert(0, nb_rouge)
    e_jaune.delete(0,END)
    e_jaune.insert(0, nb_rouge)
    e_magenta.delete(0,END)
    e_magenta.insert(0, nb_rouge)
    e_cyan.delete(0,END)
    e_cyan.insert(0, nb_rouge)
    e_carre.delete(0,END)
    e_carre.insert(0, nb_rouge)
    e_rect.delete(0,END)
    e_rect.insert(0, nb_rouge)
    e_tri.delete(0,END)
    e_tri.insert(0, nb_rouge)
    e_cercle.delete(0,END)
    e_cercle.insert(0, nb_rouge)
    e_pent.delete(0,END)
    e_pent.insert(0, nb_rouge)
    e_hexa.delete(0,END)
    e_hexa.insert(0, nb_rouge)
#remise à zéro des compteurs, chaques barre d'insertion est éffacée et contient zéro à l'appui du bouton

def update_compteur():
    global nb_rouge
    nb_rouge +=1
    eglo.delete(0,END)
    eglo.insert(0, nb_rouge)
    e_rouge.delete(0,END)
    e_rouge.insert(0, nb_rouge)
    e_bleu.delete(0,END)
    e_bleu.insert(0, nb_rouge)
    e_vert.delete(0,END)
    e_vert.insert(0, nb_rouge)
    e_orange.delete(0,END)
    e_orange.insert(0, nb_rouge)
    e_jaune.delete(0,END)
    e_jaune.insert(0, nb_rouge)
    e_magenta.delete(0,END)
    e_magenta.insert(0, nb_rouge)
    e_cyan.delete(0,END)
    e_cyan.insert(0, nb_rouge)
    e_carre.delete(0,END)
    e_carre.insert(0, nb_rouge)
    e_rect.delete(0,END)
    e_rect.insert(0, nb_rouge)
    e_tri.delete(0,END)
    e_tri.insert(0, nb_rouge)
    e_cercle.delete(0,END)
    e_cercle.insert(0, nb_rouge)
    e_pent.delete(0,END)
    e_pent.insert(0, nb_rouge)
    e_hexa.delete(0,END)
    e_hexa.insert(0, nb_rouge)
#l'objectif de ce bouton est d'aller afficher la dernière valeur des compteurs
#ici on incremente de 1 pour illustrer le fonctionnement.

#_______________________________________________________________________________
#-------------------------------------------------------------------------------
#création de la fenètre
window = Tk()

#paramètre titre et icone convoyeur
window.title("Sélection du mode")
window.iconbitmap('C:/Users/Mathieu/Desktop/Nouveau dossier/conv_ico.ico')



#fonctionnement de l'interface en 3 sous partie commande avec les boutons, dialogue avec les compteurs, et image avec l'image étudiée si updaté

#_______________________________________________________________________________
#frame COMMAND

#définition de la frame de commande de taille fixée
command_frame=LabelFrame(window, width=300, heigh=445, text="Commande", padx=5, pady=5)
command_frame.grid_propagate(False)#interdiction à la frame de se redimentionner en fonction des éléments à l'intérieur elle est de taille fixée

#définitions des éléments contenus dans la frame commande sous frame (4 sous frames) labels et boutons
frame1=LabelFrame(command_frame, width=286, heigh=110, pady=5)
frame1.grid_propagate(False)
label_switch=Label(frame1, text="Changer le mode de tri :")
b_switch=Button(frame1, command=switch, text="Switch", padx=114, pady=20)

frame2=LabelFrame(command_frame, pady=5)
vitesse_reg=Label(frame2, text="Réglage de la vitesse du tapi :                      ")
get_but=Button(frame2, text="  Get  ")#le bouton get set à obtenir la valeur fixée sur la barre horizontale en valeur normalisée, ceci permettant de contrôler la vitesse de défilement des pièces. il n'a pas de fonction car on ne peut pas observer son fonctionnement sans montage mais si on couple ce programme à un système réel il devient possible de définir, acquérir, interpréter et fixer la vitesse du tapi avec ces éléments (barre horizontale et bouton get)
horizontal=Scale(frame2, from_=0, to=1000, orient=HORIZONTAL,)

frame3=LabelFrame(command_frame, pady=5)
Bouton_zéro=Button(frame3, command=zero_comp, text="Remise à zéro des compteurs", padx=56, pady=20)

frame4=LabelFrame(command_frame, pady=5)
Bouton_updateim=Button(frame4, command=update_image, text="Update image", padx=25, pady=20)
Bouton_updatecomp=Button(frame4, command=update_compteur, text="Update compteurs", padx=12, pady=20)



#_______________________________________________________________________________
#frame DIALOGUE

#définition de la frame de commande de taille fixée
dial_frame=LabelFrame(window, width=300, heigh=445, text="Dialogue", padx=5, pady=5)
dial_frame.grid_propagate(False)

#définitions des éléments contenus dans la frame commande sous frame labels et barres d'insertions
frame_1=LabelFrame(dial_frame,width=286, heigh=60)
frame_1.grid_propagate(False)
label_mode=Label(frame_1, text="Mode de tri actuel :                                 ")
e=Entry(frame_1, width=1, borderwidth=1)
e.insert(0, "  défaut :  tri par couleur")

frame_2=LabelFrame(dial_frame, text="Compteurs :")
Label_glo=Label(frame_2, text="           Nombre de pièces :")
eglo=Entry(frame_2, width=14, borderwidth=1)
eglo.insert(0, 0)
forme=Label(frame_2, text="Formes détectées : ")
carre=Label(frame_2, text="Carrés : ")
e_carre=Entry(frame_2, width=14, borderwidth=1)
e_carre.insert(0, 0)
rectangle=Label(frame_2, text="Rectangle : ")
e_rect=Entry(frame_2, width=14, borderwidth=1)
e_rect.insert(0, 0)
triangle=Label(frame_2, text="Triangle : ")
e_tri=Entry(frame_2, width=14, borderwidth=1)
e_tri.insert(0, 0)
cercle=Label(frame_2, text="Cercle : ")
e_cercle=Entry(frame_2, width=14, borderwidth=1)
e_cercle.insert(0, 0)
pentagone=Label(frame_2, text="Pentagones : ")
e_pent=Entry(frame_2, width=14, borderwidth=1)
e_pent.insert(0, 0)
hexagones=Label(frame_2, text="Hexagones : ")
e_hexa=Entry(frame_2, width=14, borderwidth=1)
e_hexa.insert(0, 0)

label_couleur=Label(frame_2, text="Couleurs détectées : ")
rouge=Label(frame_2, text="Rouge : ")
e_rouge=Entry(frame_2, width=14, borderwidth=1)
e_rouge.insert(0, 0)
bleu=Label(frame_2, text="Bleu : ")
e_bleu=Entry(frame_2, width=14, borderwidth=1)
e_bleu.insert(0, 0)
vert=Label(frame_2, text="Vert : ")
e_vert=Entry(frame_2, width=14, borderwidth=1)
e_vert.insert(0, 0)
jaune=Label(frame_2, text="Jaune : ")
e_jaune=Entry(frame_2, width=14, borderwidth=1)
e_jaune.insert(0, 0)
orange=Label(frame_2, text="Orange : ")
e_orange=Entry(frame_2, width=14, borderwidth=1)
e_orange.insert(0, 0)
magenta=Label(frame_2, text="Magenta : ")
e_magenta=Entry(frame_2, width=14, borderwidth=1)
e_magenta.insert(0, 0)
cyan=Label(frame_2, text="Cyan : ")
e_cyan=Entry(frame_2, width=14, borderwidth=1)
e_cyan.insert(0, 0)



#_______________________________________________________________________________
#frame IMAGE

#définition de la frame de commande de taille fixée
image_frame=LabelFrame(window, width=700, heigh=445, text="Images", padx=5, pady=5)
image_frame.pack_propagate(False)

#définitions des éléments contenus dans la frame commande, barres d'insertions et canvas pour l'image
e_im=Entry(image_frame, width=470, borderwidth=1)
e_im.insert(0, "          Image : date / heure")

photo=PhotoImage(file="image_test.png")
canvas=Canvas(image_frame, width=photo.width(), height=photo.height(), bg="yellow")
canvas.create_image(0,0, anchor=NW, image=photo)



#_______________________________________________________________________________
#pack positionnement des frames principales de gauche à droite avec leurs marges
command_frame.pack(side=LEFT, padx=10, pady=10)
dial_frame.pack(side=LEFT, padx=10, pady=10)
image_frame.pack(side=LEFT, padx=10, pady=10)



#_______________________________________________________________________________
#positionnement des éléments dans les frames principales dans l'ordre par grid (avec des lignes et colonnes)
#grid frame commande
frame1.grid(row=0,column=0, sticky=W+E, pady=5)
frame2.grid(row=1,column=0, sticky=W+E, pady=5)
frame3.grid(row=2,column=0, sticky=W+E, pady=5)
frame4.grid(row=3,column=0, sticky=W+E, pady=5)
label_switch.grid(row=0, column=0,sticky=W, padx=5)
b_switch.grid(row=1, column=0, sticky=W+E, padx=5, pady=5)
vitesse_reg.grid(row=0, column=0, sticky=W, padx=5)
get_but.grid(row=0, column=1)
horizontal.grid(row=1,column=0, columnspan=2, sticky=W+E, padx=5, pady=5)
Bouton_zéro.grid(row=0, column=0, padx=5, pady=5)
Bouton_updateim.grid(row=0, column=0, padx=5, pady=5)
Bouton_updatecomp.grid(row=0, column=1, padx=5, pady=5)


#grid frame dialogue
frame_1.grid(row=0, column=0, sticky=W+E)
frame_2.grid(row=1, column=0, sticky=W+E)
label_mode.grid(row=0, column=0, sticky=W, padx=5)
e.grid(row=1, column=0, sticky=W+E, padx=5, pady=5)
Label_glo.grid(row=1, column=0, sticky=W)
eglo.grid(row=1, column=1, sticky=W+E)
forme.grid(row=2, column=0, sticky=W)
carre.grid(row=3, column=0, sticky=E)
e_carre.grid(row=3,column=1, sticky=W+E)
rectangle.grid(row=4, column=0, sticky=E)
e_rect.grid(row=4,column=1, sticky=W+E)
triangle.grid(row=5, column=0, sticky=E)
e_tri.grid(row=5,column=1, sticky=W+E)
cercle.grid(row=6, column=0, sticky=E)
e_cercle.grid(row=6,column=1, sticky=W+E)
pentagone.grid(row=7, column=0, sticky=E)
e_pent.grid(row=7,column=1, sticky=W+E)
hexagones.grid(row=8, column=0, sticky=E)
e_hexa.grid(row=8,column=1, sticky=W+E)
label_couleur.grid(row=9, column=0, sticky=W)

rouge.grid(row=10, column=0, sticky=E)
e_rouge.grid(row=10,column=1, sticky=W+E)
bleu.grid(row=11, column=0, sticky=E)
e_bleu.grid(row=11,column=1, sticky=W+E)
vert.grid(row=12, column=0, sticky=E)
e_vert.grid(row=12,column=1, sticky=W+E)
jaune.grid(row=13, column=0, sticky=E)
e_jaune.grid(row=13,column=1, sticky=W+E)
orange.grid(row=14, column=0, sticky=E)
e_orange.grid(row=14,column=1, sticky=W+E)
magenta.grid(row=15, column=0, sticky=E)
e_magenta.grid(row=15,column=1, sticky=W+E)
cyan.grid(row=16, column=0, sticky=E)
e_cyan.grid(row=16,column=1, sticky=W+E)

#grid frame image
e_im.pack()
canvas.pack()



window.mainloop()